;
;	Round1AZuR[h
;
;	AZuɂnasmgp܂B
;

%include "nasm.h"

[BITS 32]

;*************** `錾 **********************************

struc TSAT
	.PX:	resd 1
	.PY:	resd 1
	.PZ:	resd 1
	.PA:	resd 1
	.VX:	resd 1
	.VY:	resd 1
	.VZ:	resd 1
	.VA:	resd 1
endstruc


;*************** f[^ ************************************
[section .data align = 32]

		align	32
mGM		dd	-3.98666e+014		;-GM


;*************** R[h ************************************
[section .code align = 32]


;************ 3DNow!(SISD)  FPU(with fxch) u ************

	;wvZƂɂƂĂB
	;(3DNow!ł͕tŋ܂̂ł𗘗pĂ)

;void entry04(struct TSAT *psat, float dt, int count)
proc	entry04
%$psat	arg		4
%$dt	arg		4
%$count	arg		4

		;
		femms
		mov			eax, [sp(%$psat)]
		mov			ecx, [sp(%$count)]

		;fld		[GMdt2]					;GMdt
		;fld		[dt]					;dt GMdt
		;fld		[eax.P.Z]				;pz dt GMdt
		;fld		[eax.P.Y]				;py pz dt GMdt
		;fld		[eax.P.X]				;px py pz dt GMdt
		movd		mm0, [mGM]
		movd		mm1, [sp(%$dt)]
		pfmul		mm0, mm1				;GMdt
		movd		mm2, [eax+TSAT.PZ]
		movd		mm3, [eax+TSAT.PY]
		movd		mm4, [eax+TSAT.PX]

		;C[v
		align 16
	.lp:
		;fld		st(2)					;pz
		;fmul		st, st					;pzpz
		;fld		st(2)					;py pzpz
		;fmul		st, st					;pypy pzpz
		;fld		st(2)					;px pypy pzpz
		;fmul		st, st					;pxpx pypy pzpz
		;fxch		st(1)
		;faddp		st(2), st				;pxpx pypy+pzpz
		;fadd								;pxpx+pypy+pzpz
		movq		mm5, mm2
		pfmul		mm5, mm5
		movq		mm6, mm3
		pfmul		mm6, mm6
		movq		mm7, mm4
		pfmul		mm7, mm7
		pfadd		mm5, mm6
		pfadd		mm5, mm7

		;fld		st						;R R
		;fsqrt								;r R
		;fmul								;(R*r)
		;fdivr		st, st(5)				;w
		pfrsqrt		mm6, mm5
		movq		mm7, mm6
		pfmul		mm6, mm6
		pfrsqit1	mm6, mm5
		pfrcpit2	mm6, mm7				;1/r

		movq		mm5, mm6
		pfmul		mm5, mm5
		pfmul		mm5, mm6				;(1/r)^3
		pfmul		mm5, mm0				;w

		;fld		st						;w w
		;fmul		st, st(2)				;wpx w
		;fld		st(1)					;w wpx w
		;fmul		st, st(4)				;wpy wpx w
		;fxch		st(2)					;w wpx wpy
		;fmul		st, st(5)				;wpz wpx wpy
		;fxch		st(1)					;wpx wpz wpy
		movq		mm6, mm5
		pfmul		mm6, mm4
		movq		mm7, mm5
		pfmul		mm7, mm3
		pfmul		mm5, mm2

		;fadd		DWORD PTR [eax.V.X]		;vx' wpz wpy
		;fxch		st(2)					;wpy wpz vx'
		;fadd		DWORD PTR [eax.V.Y]		;vy' wpz vx'
		;fxch		st(1)					;wpz vy' vx'
		;fadd		DWORD PTR [eax.V.Z]		;vz' vy' vx'
		pfadd		mm6, [eax+TSAT.VX]
		pfadd		mm7, [eax+TSAT.VY]
		pfadd		mm5, [eax+TSAT.VZ]

		;fxch		st(2)					;vx' vy' vz'
		;fst		DWORD PTR [eax.V.X]		;vx' vy' vz'
		;fmul		st, st(6)				;vx'dt vy' vz'
		;fxch		st(1)					;vy' vx'dt vz'
		;fst		DWORD PTR [eax.V.Y]		;vy' vx'dt vz'
		;fmul		st, st(6)				;vy'dt vx'dt vz'
		;fxch		st(2)					;vz' vx'dt vy'dt
		;fst		DWORD PTR [eax.V.Z]		;vz' vx'dt vy'dt
		;fmul		st, st(6)				;vz'dt vx'dt vy'dt
		movd		[eax+TSAT.VX], mm6
		pfmul		mm6, mm1
		movd		[eax+TSAT.VY], mm7
		pfmul		mm7, mm1
		movd		[eax+TSAT.VZ], mm5
		pfmul		mm5, mm1

		;fxch		st(1)					;vx'dt vz'dt vy'dt
		;faddp		st(3), st				;vz'dt vy'dt
		;fxch		st(1)					;vy'dt vz'dt
		;faddp		st(3), st				;vz'dt
		;faddp		st(3), st
		pfadd		mm4, mm6
		pfadd		mm3, mm7
		pfadd		mm2, mm5

		dec			ecx
		jnz	near	.lp
		movd		[eax+TSAT.PX], mm4
		movd		[eax+TSAT.PY], mm3
		movd		[eax+TSAT.PZ], mm2
		femms
endproc


;************ 3DNow!(SIMD) œK(In-Order) ************

	;Q̍WlPɃpbNSIMDvZB
	;񐫂͒Ⴂłʂ͂肻B
	;sӎBŏI̓`FWeXǧoIœKB

;void entry05(struct TSAT *psat, float dt, int count);
proc	entry05
%$psat 	arg		4
%$dt	arg		4
%$count arg		4

%$GMdt	local	4
%$dtdt	local	4*2
		alloc

		;
		femms
		movd		mm0, [mGM]
		pfmul		mm0, [sp(%$dt)]
		movd		[sp(%$GMdt)], mm0

		mov			eax, [sp(%$psat)]
		movd		mm0, [sp(%$dt)]
		punpckldq	mm0, mm0
		movq		[sp(%$dtdt)], mm0

		movq		mm0, [eax+TSAT.PX]	;py | px
		movd		mm1, [eax+TSAT.PZ]	;0  | pz
		movq		mm2, [eax+TSAT.VX]	;vy | vx
		movd		mm3, [eax+TSAT.VZ]	;0  | vz

		mov			ecx, [sp(%$count)]

		;C[v
		align 16
	.lp:
		movq		mm7, mm0
		pfmul		mm0, mm0			;pypy | pxpx
		movq		mm5, mm1
		pfmul		mm1, mm1			;0 | pzpz
		pfacc		mm0, mm0			;pxpx+pypy
		pfadd		mm0, mm1			;pxpx+pypy+pzpz = R
		movq		mm1, mm5

		pfrsqrt		mm5, mm0
		movq		mm6, mm5
		pfmul		mm5, mm5
		pfrsqit1	mm5, mm0
		movd		mm4, [sp(%$GMdt)]
		pfrcpit2	mm5, mm6			;sqrt(R) = 1/r

		movq		mm6, [sp(%$dtdt)]
		movq		mm0, mm7
		pfmul		mm4, mm5			;GMdt/r
		pfmul		mm5, mm5			;1/R
		movq		mm7, mm6
		pfmul		mm4, mm5			;GMdt/(Rr) = w
		punpckldq	mm4, mm4			;w | w
		movq		mm5, mm4

		pfmul		mm4, mm0			;py*w | px*w
		pfmul		mm5, mm1			;pz*w
		pfadd		mm2, mm4			;vy' | vx'
		pfadd		mm3, mm5			;vz'
		pfmul		mm6, mm2			;vy'dt | vx'dt
		pfmul		mm7, mm3			;vz'dt
		pfadd		mm0, mm6			;py' | px'
		pfadd		mm1, mm7			;pz'

		dec			ecx
		jnz			.lp

		movq		[eax+TSAT.PX], mm0
		movd		[eax+TSAT.PZ], mm1
		movq		[eax+TSAT.VX], mm2
		movd		[eax+TSAT.VZ], mm3
		femms
endproc

;************ 3DNow!(SIMD) œK(Out-of-Order for K6) ************

	;K6̃XPW[\͂lďR[hB
	;In-OrderƂ͈Ⴂl߂̍œKB
	;łAIn-Order̕B܂ĂȂ炵B

proc	entry06
%$psat 	arg		4
%$dt	arg		4
%$count arg		4

%$GMdt	local	8
		alloc

		;
		femms
		pmov		mm0, [mGM]
		pfmul		mm0, [sp(%$dt)]
		punpckldq	mm0, mm0
		pmov		[sp(%$GMdt)], mm0

		mov			eax, [sp(%$psat)]
		pmov		mm7, [sp(%$dt)]
		punpckldq	mm7, mm7

		pmov		mm0, [eax+TSAT.PX]	;py | px
		pmov		mm1, [eax+TSAT.PZ]	;0  | pz
		pmov		mm2, [eax+TSAT.VX]	;vy | vx
		pmov		mm3, [eax+TSAT.VZ]	;0  | vz

		mov			ecx, [sp(%$count)]

		;C[v
		align 32
	.lp:
		pmov		mm4, mm0
		pmov		mm5, mm1
		pfmul		mm4, mm4			;pypy | pxpx
		pfmul		mm5, mm5			;0 | pzpz
		pfacc		mm4, mm4			;pxpx+pypy
		pfadd		mm4, mm5			;pxpx+pypy+pzpz = R

		pfrsqrt		mm5, mm4
		pmov		mm6, mm5
		punpckldq	mm4, mm4
		pfmul		mm5, mm5
		pfrsqit1	mm5, mm4
		pfrcpit2	mm5, mm6			;sqrt(R) = 1/r

		pmov		mm4, [sp(%$GMdt)]
		nop
		pfmul		mm4, mm5			;GMdt/r
		pfmul		mm5, mm5			;1/R
		pfmul		mm4, mm5			;GMdt/(Rr) = w
		pmov		mm5, mm4

		pfmul		mm4, mm0			;py*w | px*w
		pfmul		mm5, mm1			;pz*w
		pfadd		mm2, mm4			;vy' | vx'
		pfadd		mm3, mm5			;vz'
		pmov		mm4, mm7			;[sp(%$dtdt)]
		pmov		mm5, mm7
		pfmul		mm4, mm2			;vy'dt | vx'dt
		pfmul		mm5, mm3			;vz'dt
		mov			eax, eax
		pfadd		mm0, mm4			;py' | px'
		pfadd		mm1, mm5			;pz'
		
		dec			ecx
		jnz			.lp
		
		pmov		[eax+TSAT.PX], mm0
		pmov		[eax+TSAT.PZ], mm1
		pmov		[eax+TSAT.VX], mm2
		pmov		[eax+TSAT.VZ], mm3
		femms
endproc


;************ SSE(SISD)  FPU(with fxch) u ************

	;3DNow!(SISD)lwvZƂɂƂĂB
	;(tŋ܂̂𗘗pĂ)

;void entry07(struct TSAT *psat, float dt, int count);
proc	entry07
%$psat	arg		4
%$dt	arg		4
%$count	arg		4

		;
		mov			eax, [sp(%$psat)]
		mov			ecx, [sp(%$count)]

		;fld		[GMdt2]					;GMdt
		;fld		[sp(%$dt)]				;dt GMdt
		;fld		[eax.P.Z]				;pz dt GMdt
		;fld		[eax.P.Y]				;py pz dt GMdt
		;fld		[eax.P.X]				;px py pz dt GMdt
		movss		xmm0, [mGM]
		movss		xmm1, [sp(%$dt)]
		mulss		xmm0, xmm1				;GMdt
		movss		xmm2, [eax+TSAT.PZ]
		movss		xmm3, [eax+TSAT.PY]
		movss		xmm4, [eax+TSAT.PX]

		;C[v
		align 16
	.lp:
		;fld		st(2)					;pz
		;fmul		st, st					;pzpz
		;fld		st(2)					;py pzpz
		;fmul		st, st					;pypy pzpz
		;fld		st(2)					;px pypy pzpz
		;fmul		st, st					;pxpx pypy pzpz
		;fxch		st(1)
		;faddp		st(2), st				;pxpx pypy+pzpz
		;fadd								;pxpx+pypy+pzpz
		movss		xmm5, xmm2
		mulss		xmm5, xmm5
		movss		xmm6, xmm3
		mulss		xmm6, xmm6
		movss		xmm7, xmm4
		mulss		xmm7, xmm7
		addss		xmm5, xmm6
		addss		xmm5, xmm7

		;fld		st						;R R
		;fsqrt								;r R
		;fmul								;(R*r)
		;fdivr		st, st(5)				;w
		movss		xmm6, xmm5
		rsqrtss		xmm5, xmm5				;1/r
		rcpss		xmm6, xmm6				;1/R
		mulss		xmm5, xmm0				;GMdt/r
		mulss		xmm5, xmm6				;w

		;fld		st						;w w
		;fmul		st, st(2)				;wpx w
		;fld		st(1)					;w wpx w
		;fmul		st, st(4)				;wpy wpx w
		;fxch		st(2)					;w wpx wpy
		;fmul		st, st(5)				;wpz wpx wpy
		;fxch		st(1)					;wpx wpz wpy
		movss		xmm6, xmm5
		mulss		xmm6, xmm4
		movss		xmm7, xmm5
		mulss		xmm7, xmm3
		mulss		xmm5, xmm2

		;fadd		DWORD PTR [eax.V.X]		;vx' wpz wpy
		;fxch		st(2)					;wpy wpz vx'
		;fadd		DWORD PTR [eax.V.Y]		;vy' wpz vx'
		;fxch		st(1)					;wpz vy' vx'
		;fadd		DWORD PTR [eax.V.Z]		;vz' vy' vx'
		addss		xmm6, [eax+TSAT.VX]
		addss		xmm7, [eax+TSAT.VY]
		addss		xmm5, [eax+TSAT.VZ]

		;fxch		st(2)					;vx' vy' vz'
		;fst		DWORD PTR [eax.V.X]		;vx' vy' vz'
		;fmul		st, st(6)				;vx'dt vy' vz'
		;fxch		st(1)					;vy' vx'dt vz'
		;fst		DWORD PTR [eax.V.Y]		;vy' vx'dt vz'
		;fmul		st, st(6)				;vy'dt vx'dt vz'
		;fxch		st(2)					;vz' vx'dt vy'dt
		;fst		DWORD PTR [eax.V.Z]		;vz' vx'dt vy'dt
		;fmul		st, st(6)				;vz'dt vx'dt vy'dt
		movss		[eax+TSAT.VX], xmm6
		mulss		xmm6, xmm1
		movss		[eax+TSAT.VY], xmm7
		mulss		xmm7, xmm1
		movss		[eax+TSAT.VZ], xmm5
		mulss		xmm5, xmm1

		;fxch		st(1)					;vx'dt vz'dt vy'dt
		;faddp		st(3), st				;vz'dt vy'dt
		;fxch		st(1)					;vy'dt vz'dt
		;faddp		st(3), st				;vz'dt
		;faddp		st(3), st
		addss		xmm4, xmm6
		addss		xmm3, xmm7
		addss		xmm2, xmm5

		loop		.lp
		movss		[eax+TSAT.PX], xmm4
		movss		[eax+TSAT.PY], xmm3
		movss		[eax+TSAT.PZ], xmm2
endproc


;************ SSE(SIMD)  3DNow!(SIMD)u ************

	;Q̍WlPɃpbNSIMDvZB
	;Sf[^ZłSSE̋@\E悤ȎgɂȂB
	;ق3DNow!ƂP΂PΉpfacc߂̂ƁA̋t
	;P߂ŋ܂ƂɈႢB

;void entry08(struct TSAT *psat, float dt, int count);
proc	entry08
%$psat	arg		4
%$dt	arg		4
%$count	arg		4

%$GMdt	local	 4
%$dtdt	local	 4*2
		alloc

		;
		movss		xmm0, [mGM]
		mulss		xmm0, [sp(%$dt)]
		movss		[sp(%$GMdt)], xmm0

		mov			eax, [sp(%$psat)]
		movss		xmm0, [sp(%$dt)]
		unpcklps	xmm0, xmm0
		movlps		[sp(%$dtdt)], xmm0

		movlps		xmm0, [eax+TSAT.PX]	;py | px
		movss		xmm1, [eax+TSAT.PZ]	;0  | pz
		movlps		xmm2, [eax+TSAT.VX]	;vy | vx
		movss		xmm3, [eax+TSAT.VZ]	;0  | vz

		mov			ecx, [sp(%$count)]

		;C[v
		align 16
	.lp:
		movaps		xmm7, xmm0
		mulps		xmm0, xmm0			;pypy | pxpx
		movaps		xmm5, xmm1
		mulps		xmm1, xmm1			;0 | pzpz
		
		;pfacc		mm0, mm0			;pxpx+pypy
		movaps		xmm6, xmm0
		shufps		xmm6, xmm6, R4(0,0,0,1)
		addss		xmm0, xmm6
		
		addss		xmm0, xmm1			;pxpx+pypy+pzpz = R
		movaps		xmm1, xmm5

		rsqrtss		xmm5, xmm0
		movss		xmm4, [sp(%$GMdt)]

		movlps		xmm6, [sp(%$dtdt)]
		movaps		xmm0, xmm7
		mulss		xmm4, xmm5			;GMdt/r
		mulss		xmm5, xmm5			;1/R
		movaps		xmm7, xmm6
		mulss		xmm4, xmm5			;GMdt/(Rr) = w
		unpcklps	xmm4, xmm4			;w | w
		movaps		xmm5, xmm4

		mulps		xmm4, xmm0			;py*w | px*w
		mulps		xmm5, xmm1			;pz*w
		addps		xmm2, xmm4			;vy' | vx'
		addps		xmm3, xmm5			;vz'
		mulps		xmm6, xmm2			;vy'dt | vx'dt
		mulps		xmm7, xmm3			;vz'dt
		addps		xmm0, xmm6			;py' | px'
		addps		xmm1, xmm7			;pz'

		loop		.lp
		movlps		[eax+TSAT.PX], xmm0
		movss		[eax+TSAT.PZ], xmm1
		movlps		[eax+TSAT.VX], xmm2
		movss		[eax+TSAT.VZ], xmm3
endproc


;************ SSE(SIMD) œK ************

	;R̍WlPɃpbNSIMDvZB
	;pbNf[^Ԃ̉ZɂĂĂB
	;Ƒʂ̕񐫂̍f[^߂̂̂Ȃ̂œRB
	;ɃR[h肵B

;void entry09(struct TSAT *psat, float dt, int count);
proc	entry09
%$psat	arg		 4
%$dt	arg		 4
%$count	arg		 4

		;
		mov			eax, [sp(%$psat)]
		mov			ecx, [sp(%$count)]

		movss		xmm7, [sp(%$dt)]		;dt
		movaps		xmm6, xmm7
		mulss		xmm7, [mGM]				;GMdt
		shufps		xmm6, xmm6, R4(0,0,0,0)	;dt | dt | dt | dt

		movups		xmm0, [eax+TSAT.PX]		;? | pz | py | px
		movups		xmm1, [eax+TSAT.VX]		;? | vz | vy | vx

		;C[v
		align 16
	.lp:
		movaps		xmm2, xmm0
		mulps		xmm2, xmm2				;? | pzpz | pypy | pxpx

		movaps		xmm3, xmm2
		shufps		xmm3, xmm3, R4(0,0,0,1)	;pypy
		movaps		xmm4, xmm2
		shufps		xmm4, xmm4, R4(0,0,0,2)	;pzpz
		addss		xmm2, xmm3				;pxpx+pypy
		addss		xmm2, xmm4				;pxpx+pypy+pzpz = R

		rsqrtss		xmm3, xmm2				;1/r
		mulss		xmm3, xmm7				;GMdt/r
		rcpss		xmm2, xmm2				;1/R
		mulss		xmm2, xmm3				;GMdt/(Rr) = w
		movaps		xmm4, xmm6				;dt | dt | dt | dt
		shufps		xmm2, xmm2, R4(0,0,0,0)	;w | w | w | w

		mulps		xmm2, xmm0				;? | pz*w | py*w | px*w
		addps		xmm1, xmm2				;? | vz' | vy' | vx'
		mulps		xmm4, xmm1				;? | vz'dt | vy'dt | vx'dt
		addps		xmm0, xmm4				;? | pz' | py' | px'

		loop		.lp
		movups		[eax+TSAT.PX], xmm0
		movups		[eax+TSAT.VX], xmm1
endproc
